#include <Windows.h>
#include "PDFChart-BCC.h"


UINT ShowError(char *which, UINT iErr)
{
	char message[200];
	
	wsprintf(message, "%s returned error %d", which, iErr);

	MessageBox(NULL, message, "Error Returned From PDFChart DLL", MB_OK | MB_ICONERROR);

	return iErr;
}

void DoExampleBarChart(void)
{
	UINT	iErr;
	char	errorText[1024];

	PDFC_Chart(CHART_BAR_HORIZONTAL);
	PDFC_Page(600, 400, 0xcc / 255.0, 0xcc / 255.0, 0xff / 255.0); // #ccccff

	PDFC_BarDatum("1950", 2556);
	PDFC_BarDatum("1960", 3040);
	PDFC_BarDatum("1970", 3707);
	PDFC_BarDatum("1980", 4454);
	PDFC_BarDatum("1990", 5277);
	PDFC_BarDatum("2000", 6073);

	PDFC_ChartHeading(VERTICAL_ALIGNMENT_TOP, HORIZONTAL_ALIGNMENT_CENTER);
	PDFC_HeadingTitle(   14, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_HeadingSubTitle(12, FONT_ID_TIMES_BOLDITALIC, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_ChartBackground(0x80 / 255.0, 0x80 / 255.0, 0x80 / 255.0, 0xff / 255.0, 0xff / 255.0, 0xff / 255.0); // #808080 #ffffff

	PDFC_DecimalPoints(0);

	PDFC_AxesCaptionX(14, FONT_ID_TIMES_BOLD, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0, HORIZONTAL_ALIGNMENT_CENTER, "World Population (Millions)"); // #3333ff
	PDFC_AxesCaptionY(14, FONT_ID_TIMES_BOLD, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0, VERTICAL_ALIGNMENT_MIDDLE,   "Year"); // #3333ff

	PDFC_AxesLabelX(   12, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_AxesLabelY(   12, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff

	PDFC_AxesLine(    1.0, 0.0, 0.0, 0.0, AXES_LINE_FULL);
	PDFC_AxesGridLine(1.0, 0.0, 0.0, 0.0);

	PDFC_AxesDivisions(9);
	PDFC_AxesScale(AXES_SCALE_RANGE, 2000, 6500);

	PDFC_AxesGridLineStyle(7, 7, 4);

	PDFC_BarBorder(1.0, 0.0, 0.0, 0.0);
	PDFC_BarColor(0.0, 0xcc / 255.0, 0.0, 0x99 / 255.0, 0xff / 255.0, 0xff / 255.0); // #00cc00 #99ffff
	PDFC_BarSpacing(7);

	PDFC_BarLabel(LABEL_AT_AXES_AND_END, "");

	PDFC_SetTitle("Example Horizontal Bar Chart produced by the PDF Chart Creator from Utility Warrior");
	PDFC_SetSubject("For more information please visit http://www.UtilityWarrior.com/PDF-Chart-Creator.htm");

	iErr = PDFC_MakePDF("testbar.pdf", OPTION_OPEN_PDF | OPTION_RESET, errorText, sizeof(errorText));
	if (iErr)
	{
		if (iErr == 1)
			ShowError(errorText, iErr);
		else
			ShowError("PDFC_MakePDF", iErr);
	}
}

void DoExamplePieChart(void)
{
	UINT	iErr;
	char	errorText[1024];

	PDFC_Chart(CHART_PIE_2D);
	PDFC_Page(600, 400, 0xcc / 255.0, 0xcc / 255.0, 0xff / 255.0); // #ccccff

	PDFC_PieDatum("Banana",		9); 
	PDFC_PieDatum("Apple",		8);
	PDFC_PieDatum("Pear",		7);
	PDFC_PieDatum("Strawberry", 6);
	PDFC_PieDatum("Lychee",		5);
	PDFC_PieDatum("Apricot",	4);
	PDFC_PieDatum("Blackberry", 3);
	PDFC_PieDatum("Blueberry",	2);
	PDFC_PieDatum("Grape",		1);

	PDFC_ChartHeading(VERTICAL_ALIGNMENT_TOP, HORIZONTAL_ALIGNMENT_CENTER);
	PDFC_HeadingTitle(   14, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_HeadingSubTitle(12, FONT_ID_TIMES_BOLDITALIC, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_ChartBackground(0x80 / 255.0, 0x80 / 255.0, 0x80 / 255.0, 0xff / 255.0, 0xff / 255.0, 0xff / 255.0); // #808080 #ffffff

	PDFC_PieColor(0xff / 255.0, 0xff / 255.0, 0x00 / 255.0); // #ffff00
	PDFC_PieColor(0x00 / 255.0, 0xff / 255.0, 0x00 / 255.0); // #00ff00
	PDFC_PieColor(0xcc / 255.0, 0x99 / 255.0, 0x00 / 255.0); // #cc9900
	PDFC_PieColor(0xff / 255.0, 0x00 / 255.0, 0x00 / 255.0); // #ff0000
	PDFC_PieColor(0xdd / 255.0, 0x99 / 255.0, 0x99 / 255.0); // #dd9999
	PDFC_PieColor(0xff / 255.0, 0xbb / 255.0, 0x00 / 255.0); // #ffbb00
	PDFC_PieColor(0x44 / 255.0, 0x44 / 255.0, 0x44 / 255.0); // #444444
	PDFC_PieColor(0x00 / 255.0, 0x00 / 255.0, 0xcc / 255.0); // #0000cc
	PDFC_PieColor(0xdd / 255.0, 0x00 / 255.0, 0xff / 255.0); // #dd00ff

	PDFC_PieOutline(1.0, 0xff / 255.0, 0xff / 255.0, 0xff / 255.0); // #ffffff
	PDFC_PiePageMargin(5.0);
	PDFC_PieLabel(LABEL_OUTSIDE, "VVVV", 12, FONT_ID_TIMES_BOLD, 0.0, 0.0, 0.0, TEXT_STYLE_NORMAL, 0, 0, 0);
	PDFC_Legend(LEGEND_RIGHT, "VVVV - TTTT", 1.0, 1.0, 1.0, 2.0, 0x66 / 255.0, 0x66 / 255.0, 0xff / 255.0, 12, FONT_ID_TIMES_BOLD, 0.0, 0.0, 0.0, TEXT_STYLE_NORMAL, 0, 0, 0);

	PDFC_SetTitle("Example Pie Chart produced by the PDF Chart Creator from Utility Warrior");
	PDFC_SetSubject("For more information please visit http://www.UtilityWarrior.com/PDF-Chart-Creator.htm");

	iErr = PDFC_MakePDF("testpie.pdf", OPTION_OPEN_PDF | OPTION_RESET, errorText, sizeof(errorText));
	if (iErr)
	{
		if (iErr == 1)
			ShowError(errorText, iErr);
		else
			ShowError("PDFC_MakePDF", iErr);
	}
}

void DoExampleAreaChart(void)
{
	UINT	iErr;
	char	errorText[1024];

	PDFC_Chart(CHART_AREA_CURVED);
	PDFC_Page(600, 400, 0xcc / 255.0, 0xcc / 255.0, 0xff / 255.0); // #ccccff

	PDFC_AreaDatum("01", 30.47);
	PDFC_AreaDatum("02", 30.39);
	PDFC_AreaDatum("03", 30.56);
	PDFC_AreaDatum("04", 30.12);
	PDFC_AreaDatum("05", 29.02);
	PDFC_AreaDatum("06", 28.61);
	PDFC_AreaDatum("07", 28.55);
	PDFC_AreaDatum("08", 27.87);
	PDFC_AreaDatum("09", 28.02);
	PDFC_AreaDatum("10", 27.33);
	PDFC_AreaDatum("11", 27.28);
	PDFC_AreaDatum("12", 27.76);
	PDFC_AreaDatum("13", 28.90);
	PDFC_AreaDatum("14", 28.74);
	PDFC_AreaDatum("15", 28.98);
	PDFC_AreaDatum("16", 30.19);
	PDFC_AreaDatum("17", 30.60);
	PDFC_AreaDatum("18", 31.11);
	PDFC_AreaDatum("19", 31.21);
	PDFC_AreaDatum("20", 29.64);
	PDFC_AreaDatum("21", 29.86);
	PDFC_AreaDatum("22", 29.64);
	PDFC_AreaDatum("23", 30.19);
	PDFC_AreaDatum("24", 29.40);
	PDFC_AreaDatum("25", 29.12);
	PDFC_AreaDatum("26", 29.76);
	PDFC_AreaDatum("27", 29.40);
	PDFC_AreaDatum("28", 29.24);
	PDFC_AreaDatum("29", 28.73);
	PDFC_AreaDatum("30", 28.34);
	PDFC_AreaDatum("31", 28.43);
	PDFC_AreaDatum("32", 28.37);
	PDFC_AreaDatum("33", 27.87);
	PDFC_AreaDatum("34", 27.35);
	PDFC_AreaDatum("35", 26.66);
	PDFC_AreaDatum("36", 26.85);
	PDFC_AreaDatum("37", 25.60);
	PDFC_AreaDatum("38", 25.84);
	PDFC_AreaDatum("39", 25.85);
	PDFC_AreaDatum("40", 25.79);
	PDFC_AreaDatum("41", 24.43);
	PDFC_AreaDatum("42", 24.29);
	PDFC_AreaDatum("43", 24.25);
	PDFC_AreaDatum("44", 23.87);
	PDFC_AreaDatum("45", 22.29);
	PDFC_AreaDatum("46", 23.30);
	PDFC_AreaDatum("47", 23.30);
	PDFC_AreaDatum("48", 22.50);
	PDFC_AreaDatum("49", 22.10);
	PDFC_AreaDatum("50", 21.92);
	PDFC_AreaDatum("51", 22.76);
	PDFC_AreaDatum("52", 23.72);

	PDFC_DecimalPoints(0);

	PDFC_AxesCaptionX(14, FONT_ID_TIMES_BOLD, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0, HORIZONTAL_ALIGNMENT_CENTER, "Week"); // #3333ff
	PDFC_AxesCaptionY(14, FONT_ID_TIMES_BOLD, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0, VERTICAL_ALIGNMENT_MIDDLE,   "Stock Price"); // #3333ff

	PDFC_AxesLabelX(   12, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_AxesLabelY(   12, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff

	PDFC_AxesLine(    1.0, 0.0, 0.0, 0.0, AXES_LINE_FULL);
	PDFC_AxesGridLine(1.0, 0.0, 0.0, 0.0);

	PDFC_AxesDivisions(9);
	PDFC_AxesScale(AXES_SCALE_RANGE, 21, 32);

	PDFC_AxesGridLineStyle(7, 7, 4);

	PDFC_AxesLabelSpacing(2);

	PDFC_Area(0x99 / 255.0, 0x33 / 255.0, 0x00 / 255.0, 2.0, 0xcc / 255.0, 0x99 / 255.0, 0x00 / 255.0); // #993300 #cc9900

	PDFC_MovingAverageLine(4, 0xff / 255.0, 0x00 / 255.0, 0x00 / 255.0, 2.0); // ff0000
	// don't show line point marker for smoothed lines
	// PDFC_MovingAverageLineMarker(LINE_POINT_STYLE_OUTLINE_CIRCLE, 0x99 / 255.0, 0x00 / 255.0, 0x00 / 255.0, 7.0, 2.0); // #990000

	PDFC_ChartHeading(VERTICAL_ALIGNMENT_TOP, HORIZONTAL_ALIGNMENT_CENTER);
	PDFC_HeadingTitle(   14, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_HeadingSubTitle(12, FONT_ID_TIMES_BOLDITALIC, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_ChartBackground(0xff / 255.0, 0xff / 255.0, 0x00 / 255.0, 0xff / 255.0, 0xff / 255.0, 0x99 / 255.0); // #ffff00 #ffff99

	PDFC_SetTitle("Example Area Chart produced by the PDF Chart Creator from Utility Warrior");
	PDFC_SetSubject("For more information please visit http://www.UtilityWarrior.com/PDF-Chart-Creator.htm");

	iErr = PDFC_MakePDF("testarea.pdf", OPTION_OPEN_PDF | OPTION_RESET, errorText, sizeof(errorText));
	if (iErr)
	{
		if (iErr == 1)
			ShowError(errorText, iErr);
		else
			ShowError("PDFC_MakePDF", iErr);
	}
}

void DoExampleLineChart(void)
{
	UINT	iErr;
	char	errorText[1024];

	PDFC_Chart(CHART_LINE_STEPPED);
	PDFC_Page(600, 400, 0xcc / 255.0, 0xcc / 255.0, 0xff / 255.0); // #ccccff

	PDFC_LineDatum("01", 26.47);
	PDFC_LineDatum("02", 26.19);
	PDFC_LineDatum("03", 25.56);
	PDFC_LineDatum("04", 25.12);
	PDFC_LineDatum("05", 26.02);
	PDFC_LineDatum("06", 26.61);
	PDFC_LineDatum("07", 26.55);
	PDFC_LineDatum("08", 26.87);
	PDFC_LineDatum("09", 27.02);
	PDFC_LineDatum("10", 27.33);
	PDFC_LineDatum("11", 27.28);
	PDFC_LineDatum("12", 27.76);
	PDFC_LineDatum("13", 28.90);
	PDFC_LineDatum("14", 28.74);
	PDFC_LineDatum("15", 28.98);
	PDFC_LineDatum("16", 30.19);
	PDFC_LineDatum("17", 30.60);
	PDFC_LineDatum("18", 31.11);
	PDFC_LineDatum("19", 31.21);
	PDFC_LineDatum("20", 29.64);
	PDFC_LineDatum("21", 29.86);
	PDFC_LineDatum("22", 29.64);
	PDFC_LineDatum("23", 30.19);
	PDFC_LineDatum("24", 30.40);
	PDFC_LineDatum("25", 31.12);
	PDFC_LineDatum("26", 31.76);
	PDFC_LineDatum("27", 31.40);
	PDFC_LineDatum("28", 32.24);
	PDFC_LineDatum("29", 32.73);
	PDFC_LineDatum("30", 33.34);

	PDFC_DecimalPoints(0);

	PDFC_AxesCaptionX(14, FONT_ID_TIMES_BOLD, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0, HORIZONTAL_ALIGNMENT_CENTER, "Week"); // #3333ff
	PDFC_AxesCaptionY(14, FONT_ID_TIMES_BOLD, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0, VERTICAL_ALIGNMENT_MIDDLE,   "Stock Price"); // #3333ff

	PDFC_AxesLabelX(   12, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_AxesLabelY(   12, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff

	PDFC_AxesLine(    1.0, 0.0, 0.0, 0.0, AXES_LINE_FULL);
	PDFC_AxesGridLine(1.0, 0.0, 0.0, 0.0);

	PDFC_AxesDivisions(9);
	PDFC_AxesScale(AXES_SCALE_RANGE, 25, 34);

	PDFC_AxesGridLineStyle(7, 7, 4);

	PDFC_AxesLabelSpacing(2);

	PDFC_Line(0x00 / 255.0, 0x00 / 255.0, 0xff / 255.0, 1.0); // #000000
	PDFC_LineMarker(0x00 / 255.0, 0x00 / 255.0, 0xcc / 255.0, 7.0, LINE_POINT_STYLE_CROSS, 2.0); // #0000cc

	PDFC_LineOfBestFit(0xcc / 255.0, 0x00 / 255.0, 0x00 / 255.0, 2.0); // #cc0000

	PDFC_ChartHeading(VERTICAL_ALIGNMENT_TOP, HORIZONTAL_ALIGNMENT_CENTER);
	PDFC_HeadingTitle(   14, FONT_ID_TIMES_BOLD,       0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_HeadingSubTitle(12, FONT_ID_TIMES_BOLDITALIC, 0x33 / 255.0, 0x33 / 255.0, 0xff / 255.0, TEXT_STYLE_NORMAL, 0, 0, 0); // #3333ff
	PDFC_ChartBackground(0xff / 255.0, 0xff / 255.0, 0x00 / 255.0, 0xff / 255.0, 0xff / 255.0, 0x99 / 255.0); // #ffff00 #ffff99

	PDFC_SetTitle("Example Line Chart produced by the PDF Chart Creator from Utility Warrior");
	PDFC_SetSubject("For more information please visit http://www.UtilityWarrior.com/PDF-Chart-Creator.htm");

	iErr = PDFC_MakePDF("testline.pdf", OPTION_OPEN_PDF | OPTION_RESET, errorText, sizeof(errorText));
	if (iErr)
	{
		if (iErr == 1)
			ShowError(errorText, iErr);
		else
			ShowError("PDFC_MakePDF", iErr);
	}
}


int PASCAL WinMain(HINSTANCE hCurrentInstance, HINSTANCE hPreviousInstance,
                   LPSTR lpszCommandLine, int iCommandShow)
{
	DoExampleBarChart();
	DoExamplePieChart();
	DoExampleAreaChart();
	DoExampleLineChart();
	
	return 0;
}
