Imports System.Runtime.InteropServices
Imports System.Text


Module Module1
    Declare Auto Function MessageBox Lib "user32.dll" Alias _
        "MessageBox" (ByVal hWnd As Integer, ByVal msg As String, _
        ByVal Caption As String, ByVal Type As Integer) As Integer


    Sub ShowError(ByVal which, ByVal iErr)
        Dim message As String
        message = which + " returned error " + CStr(iErr)
        MessageBox(0, message, "Error Returned From PDFChart DLL", 0)
    End Sub

    Sub DoExampleBarChart()
        Dim iErr As Integer
        Dim errorText As String = Space(1000)
        Dim errorTextLen As Integer = errorText.Length

        Win32.PDFC_Chart(Win32.CHART_BAR_HORIZONTAL)
        Win32.PDFC_Page(600, 400, 0.8, 0.8, 1.0) ' #ccccff

        Win32.PDFC_BarDatum("1950", 2556)
        Win32.PDFC_BarDatum("1960", 3040)
        Win32.PDFC_BarDatum("1970", 3707)
        Win32.PDFC_BarDatum("1980", 4454)
        Win32.PDFC_BarDatum("1990", 5277)
        Win32.PDFC_BarDatum("2000", 6073)

        Win32.PDFC_ChartHeading(Win32.VERTICAL_ALIGNMENT_TOP, Win32.HORIZONTAL_ALIGNMENT_CENTER)
        Win32.PDFC_HeadingTitle(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff
        Win32.PDFC_HeadingSubTitle(12, Win32.FONT_ID_TIMES_BOLDITALIC, 0.2, 0.2, 1.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff
        Win32.PDFC_ChartBackground(0.5, 0.5, 0.5, 1.0, 1.0, 1.0) ' #808080 #ffffff

        Win32.PDFC_DecimalPoints(0)

        Win32.PDFC_AxesCaptionX(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0, Win32.HORIZONTAL_ALIGNMENT_CENTER, "World Population (Millions)") ' #3333ff
        Win32.PDFC_AxesCaptionY(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0, Win32.VERTICAL_ALIGNMENT_MIDDLE, "Year") ' #3333ff

        Win32.PDFC_AxesLabelX(12, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff
        Win32.PDFC_AxesLabelY(12, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff

        Win32.PDFC_AxesLine(1.0, 0.0, 0.0, 0.0, Win32.AXES_LINE_FULL)
        Win32.PDFC_AxesGridLine(1.0, 0.0, 0.0, 0.0)

        Win32.PDFC_AxesDivisions(9)
        Win32.PDFC_AxesScale(Win32.AXES_SCALE_RANGE, 2000, 6500)

        Win32.PDFC_AxesGridLineStyle(7, 7, 4)

        Win32.PDFC_BarBorder(1.0, 0.0, 0.0, 0.0)
        Win32.PDFC_BarColor(0.0, 0.8, 0.0, 0.6, 1.0, 1.0) ' #00cc00 #99ffff
        Win32.PDFC_BarSpacing(7)

        Win32.PDFC_BarLabel(Win32.LABEL_AT_AXES_AND_END, "")

        Win32.PDFC_SetTitle("Example Horizontal Bar Chart produced by the PDF Chart Creator from Utility Warrior")
        Win32.PDFC_SetSubject("For more information please visit http://www.UtilityWarrior.com/PDF-Chart-Creator.htm")

        iErr = Win32.PDFC_MakePDF("testbar.pdf", Win32.OPTION_OPEN_PDF + Win32.OPTION_RESET, errorText, errorTextLen)
        If (iErr > 0) Then
            If (iErr = 3) Then
                ShowError(errorText, iErr)
            Else
                ShowError("PDFC_MakePDF", iErr)
            End If
        End If
    End Sub


    Sub DoExamplePieChart()
        Dim iErr As Integer
        Dim errorText As String = Space(1000)
        Dim errorTextLen As Integer = errorText.Length

        Win32.PDFC_Chart(Win32.CHART_PIE_2D)
        Win32.PDFC_Page(600, 400, 0.8, 0.8, 1.0) ' #ccccff

        Win32.PDFC_PieDatum("Banana", 9)
        Win32.PDFC_PieDatum("Apple", 8)
        Win32.PDFC_PieDatum("Pear", 7)
        Win32.PDFC_PieDatum("Strawberry", 6)
        Win32.PDFC_PieDatum("Lychee", 5)
        Win32.PDFC_PieDatum("Apricot", 4)
        Win32.PDFC_PieDatum("Blackberry", 3)
        Win32.PDFC_PieDatum("Blueberry", 2)
        Win32.PDFC_PieDatum("Grape", 1)

        Win32.PDFC_ChartHeading(Win32.VERTICAL_ALIGNMENT_TOP, Win32.HORIZONTAL_ALIGNMENT_CENTER)
        Win32.PDFC_HeadingTitle(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff
        Win32.PDFC_HeadingSubTitle(12, Win32.FONT_ID_TIMES_BOLDITALIC, 0.2, 0.2, 1.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff
        Win32.PDFC_ChartBackground(0.5, 0.5, 0.5, 1.0, 1.0, 1.0) ' #808080 #ffffff

        Win32.PDFC_PieColor(1.0, 1.0, 0.0)    ' #ffff00
        Win32.PDFC_PieColor(0.0, 1.0, 0.0)    ' #00ff00
        Win32.PDFC_PieColor(0.8, 0.6, 0.0)    ' #cc9900
        Win32.PDFC_PieColor(1.0, 0.0, 0.0)    ' #ff0000
        Win32.PDFC_PieColor(0.87, 0.6, 0.6)   ' #dd9999
        Win32.PDFC_PieColor(1.0, 0.73, 0.0)   ' #ffbb00
        Win32.PDFC_PieColor(0.27, 0.27, 0.27) ' #444444
        Win32.PDFC_PieColor(0.0, 0.0, 0.8)    ' #0000cc
        Win32.PDFC_PieColor(0.87, 0.0, 1.0)   ' #dd00ff

        Win32.PDFC_PieOutline(1.0, 1.0, 1.0, 1.0) ' #ffffff
        Win32.PDFC_PiePageMargin(5.0)
        Win32.PDFC_PieLabel(Win32.LABEL_OUTSIDE, "VVVV", 12, Win32.FONT_ID_TIMES_BOLD, 0.0, 0.0, 0.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0)
        Win32.PDFC_Legend(Win32.LEGEND_RIGHT, "VVVV - TTTT", 1.0, 1.0, 1.0, 2.0, 0.4, 0.4, 1.0, 12, Win32.FONT_ID_TIMES_BOLD, 0.0, 0.0, 0.0, Win32.TEXT_STYLE_NORMAL, 0, 0, 0)

        Win32.PDFC_SetTitle("Example Pie Chart produced by the PDF Chart Creator from Utility Warrior")
        Win32.PDFC_SetSubject("For more information please visit http://www.UtilityWarrior.com/PDF-Chart-Creator.htm")

        iErr = Win32.PDFC_MakePDF("testpie.pdf", Win32.OPTION_OPEN_PDF + Win32.OPTION_RESET, errorText, errorTextLen)
        If (iErr > 0) Then
            If (iErr = 3) Then
                ShowError(errorText, iErr)
            Else
                ShowError("PDFC_MakePDF", iErr)
            End If
        End If
    End Sub

    Sub DoExampleAreaChart()
        Dim iErr As Integer
        Dim errorText As String = Space(1000)
        Dim errorTextLen As Integer = errorText.Length

        Win32.PDFC_Chart(Win32.CHART_AREA_CURVED)
        Win32.PDFC_Page(600, 400, 0.8, 0.8, 1.0#)   ' #ccccff

        Win32.PDFC_AreaDatum("01", 30.47)
        Win32.PDFC_AreaDatum("02", 30.39)
        Win32.PDFC_AreaDatum("03", 30.56)
        Win32.PDFC_AreaDatum("04", 30.12)
        Win32.PDFC_AreaDatum("05", 29.02)
        Win32.PDFC_AreaDatum("06", 28.61)
        Win32.PDFC_AreaDatum("07", 28.55)
        Win32.PDFC_AreaDatum("08", 27.87)
        Win32.PDFC_AreaDatum("09", 28.02)
        Win32.PDFC_AreaDatum("10", 27.33)
        Win32.PDFC_AreaDatum("11", 27.28)
        Win32.PDFC_AreaDatum("12", 27.76)
        Win32.PDFC_AreaDatum("13", 28.9)
        Win32.PDFC_AreaDatum("14", 28.74)
        Win32.PDFC_AreaDatum("15", 28.98)
        Win32.PDFC_AreaDatum("16", 30.19)
        Win32.PDFC_AreaDatum("17", 30.6)
        Win32.PDFC_AreaDatum("18", 31.11)
        Win32.PDFC_AreaDatum("19", 31.21)
        Win32.PDFC_AreaDatum("20", 29.64)
        Win32.PDFC_AreaDatum("21", 29.86)
        Win32.PDFC_AreaDatum("22", 29.64)
        Win32.PDFC_AreaDatum("23", 30.19)
        Win32.PDFC_AreaDatum("24", 29.4)
        Win32.PDFC_AreaDatum("25", 29.12)
        Win32.PDFC_AreaDatum("26", 29.76)
        Win32.PDFC_AreaDatum("27", 29.4)
        Win32.PDFC_AreaDatum("28", 29.24)
        Win32.PDFC_AreaDatum("29", 28.73)
        Win32.PDFC_AreaDatum("30", 28.34)
        Win32.PDFC_AreaDatum("31", 28.43)
        Win32.PDFC_AreaDatum("32", 28.37)
        Win32.PDFC_AreaDatum("33", 27.87)
        Win32.PDFC_AreaDatum("34", 27.35)
        Win32.PDFC_AreaDatum("35", 26.66)
        Win32.PDFC_AreaDatum("36", 26.85)
        Win32.PDFC_AreaDatum("37", 25.6)
        Win32.PDFC_AreaDatum("38", 25.84)
        Win32.PDFC_AreaDatum("39", 25.85)
        Win32.PDFC_AreaDatum("40", 25.79)
        Win32.PDFC_AreaDatum("41", 24.43)
        Win32.PDFC_AreaDatum("42", 24.29)
        Win32.PDFC_AreaDatum("43", 24.25)
        Win32.PDFC_AreaDatum("44", 23.87)
        Win32.PDFC_AreaDatum("45", 22.29)
        Win32.PDFC_AreaDatum("46", 23.3)
        Win32.PDFC_AreaDatum("47", 23.3)
        Win32.PDFC_AreaDatum("48", 22.5)
        Win32.PDFC_AreaDatum("49", 22.1)
        Win32.PDFC_AreaDatum("50", 21.92)
        Win32.PDFC_AreaDatum("51", 22.76)
        Win32.PDFC_AreaDatum("52", 23.72)

        Win32.PDFC_DecimalPoints(0)

        Win32.PDFC_AxesCaptionX(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0, Win32.HORIZONTAL_ALIGNMENT_CENTER, "Week")       ' #3333ff
        Win32.PDFC_AxesCaptionY(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0, Win32.VERTICAL_ALIGNMENT_MIDDLE, "Stock Price")  ' #3333ff

        Win32.PDFC_AxesLabelX(12, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff
        Win32.PDFC_AxesLabelY(12, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff

        Win32.PDFC_AxesLine(1.0#, 0.0#, 0.0#, 0.0#, Win32.AXES_LINE_FULL)
        Win32.PDFC_AxesGridLine(1.0#, 0.0#, 0.0#, 0.0#)

        Win32.PDFC_AxesDivisions(9)
        Win32.PDFC_AxesScale(Win32.AXES_SCALE_RANGE, 21, 32)

        Win32.PDFC_AxesGridLineStyle(7, 7, 4)

        Win32.PDFC_AxesLabelSpacing(2)

        Win32.PDFC_Area(0.6, 0.2, 0.0#, 2.0#, 0.8, 0.6, 0.0#)    ' #993300 #cc9900

        Win32.PDFC_MovingAverageLine(4, 1.0#, 0.0#, 0.0#, 2.0#)    ' ff0000
        ' don't show line point marker for smoothed lines
        ' Win32.PDFC_MovingAverageLineMarker(Win32.LINE_POINT_STYLE_OUTLINE_CIRCLE, 0.6, 0.0#, 0.0#, 7.0#, 2.0#)     ' #990000

        Win32.PDFC_ChartHeading(Win32.VERTICAL_ALIGNMENT_TOP, Win32.HORIZONTAL_ALIGNMENT_CENTER)
        Win32.PDFC_HeadingTitle(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0)           ' #3333ff
        Win32.PDFC_HeadingSubTitle(12, Win32.FONT_ID_TIMES_BOLDITALIC, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0)  ' #3333ff
        Win32.PDFC_ChartBackground(1.0#, 1.0#, 0.0#, 1.0#, 1.0#, 0.6)      ' #ffff00 #ffff99

        Win32.PDFC_SetTitle("Example Area Chart produced by the PDF Chart Creator from Utility Warrior")
        Win32.PDFC_SetSubject("For more information please visit http://www.UtilityWarrior.com/PDF-Chart-Creator.htm")

        iErr = Win32.PDFC_MakePDF("testarea.pdf", Win32.OPTION_OPEN_PDF + Win32.OPTION_RESET, errorText, errorTextLen)
        If (iErr > 0) Then
            If (iErr = 3) Then
                ShowError(errorText, iErr)
            Else
                ShowError("PDFC_MakePDF", iErr)
            End If
        End If
    End Sub

    Sub DoExampleLineChart()
        Dim iErr As Integer
        Dim errorText As String = Space(1000)
        Dim errorTextLen As Integer = errorText.Length

        Win32.PDFC_Chart(Win32.CHART_LINE_STEPPED)
        Win32.PDFC_Page(600, 400, 0.8, 0.8, 1.0#)   ' #ccccff

        Win32.PDFC_LineDatum("01", 26.47)
        Win32.PDFC_LineDatum("02", 26.19)
        Win32.PDFC_LineDatum("03", 25.56)
        Win32.PDFC_LineDatum("04", 25.12)
        Win32.PDFC_LineDatum("05", 26.02)
        Win32.PDFC_LineDatum("06", 26.61)
        Win32.PDFC_LineDatum("07", 26.55)
        Win32.PDFC_LineDatum("08", 26.87)
        Win32.PDFC_LineDatum("09", 27.02)
        Win32.PDFC_LineDatum("10", 27.33)
        Win32.PDFC_LineDatum("11", 27.28)
        Win32.PDFC_LineDatum("12", 27.76)
        Win32.PDFC_LineDatum("13", 28.9)
        Win32.PDFC_LineDatum("14", 28.74)
        Win32.PDFC_LineDatum("15", 28.98)
        Win32.PDFC_LineDatum("16", 30.19)
        Win32.PDFC_LineDatum("17", 30.6)
        Win32.PDFC_LineDatum("18", 31.11)
        Win32.PDFC_LineDatum("19", 31.21)
        Win32.PDFC_LineDatum("20", 29.64)
        Win32.PDFC_LineDatum("21", 29.86)
        Win32.PDFC_LineDatum("22", 29.64)
        Win32.PDFC_LineDatum("23", 30.19)
        Win32.PDFC_LineDatum("24", 30.4)
        Win32.PDFC_LineDatum("25", 31.12)
        Win32.PDFC_LineDatum("26", 31.76)
        Win32.PDFC_LineDatum("27", 31.4)
        Win32.PDFC_LineDatum("28", 32.24)
        Win32.PDFC_LineDatum("29", 32.73)
        Win32.PDFC_LineDatum("30", 33.34)

        Win32.PDFC_DecimalPoints(0)

        Win32.PDFC_AxesCaptionX(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0, Win32.HORIZONTAL_ALIGNMENT_CENTER, "Week")       ' #3333ff
        Win32.PDFC_AxesCaptionY(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0, Win32.VERTICAL_ALIGNMENT_MIDDLE, "Stock Price")  ' #3333ff

        Win32.PDFC_AxesLabelX(12, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff
        Win32.PDFC_AxesLabelY(12, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0) ' #3333ff

        Win32.PDFC_AxesLine(1.0#, 0.0#, 0.0#, 0.0#, Win32.AXES_LINE_FULL)
        Win32.PDFC_AxesGridLine(1.0#, 0.0#, 0.0#, 0.0#)

        Win32.PDFC_AxesDivisions(9)
        Win32.PDFC_AxesScale(Win32.AXES_SCALE_RANGE, 25, 34)

        Win32.PDFC_AxesGridLineStyle(7, 7, 4)

        Win32.PDFC_AxesLabelSpacing(2)

        Win32.PDFC_Line(0.0#, 0.0#, 1.0#, 1.0#)     ' #000000
        Win32.PDFC_LineMarker(0.0#, 0.0#, 0.8, 7.0#, Win32.LINE_POINT_STYLE_CROSS, 2.0#)     ' #0000cc

        Win32.PDFC_LineOfBestFit(0.8, 0.0#, 0.0#, 2.0#)    ' #cc0000

        Win32.PDFC_ChartHeading(Win32.VERTICAL_ALIGNMENT_TOP, Win32.HORIZONTAL_ALIGNMENT_CENTER)
        Win32.PDFC_HeadingTitle(14, Win32.FONT_ID_TIMES_BOLD, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0)           ' #3333ff
        Win32.PDFC_HeadingSubTitle(12, Win32.FONT_ID_TIMES_BOLDITALIC, 0.2, 0.2, 1.0#, Win32.TEXT_STYLE_NORMAL, 0, 0, 0)  ' #3333ff
        Win32.PDFC_ChartBackground(1.0#, 1.0#, 0.0#, 1.0#, 1.0#, 0.6)      ' #ffff00 #ffff99

        Win32.PDFC_SetTitle("Example Line Chart produced by the PDF Chart Creator from Utility Warrior")
        Win32.PDFC_SetSubject("For more information please visit http://www.UtilityWarrior.com/PDF-Chart-Creator.htm")

        iErr = Win32.PDFC_MakePDF("testline.pdf", Win32.OPTION_OPEN_PDF + Win32.OPTION_RESET, errorText, errorTextLen)
        If (iErr > 0) Then
            If (iErr = 3) Then
                ShowError(errorText, iErr)
            Else
                ShowError("PDFC_MakePDF", iErr)
            End If
        End If
    End Sub

    Sub Main()
        DoExampleBarChart()
        DoExamplePieChart()
        DoExampleAreaChart()
        DoExampleLineChart()
    End Sub
End Module
